/* AMX Mod X
*   Satchels Life Time
*
* (c) Copyright 2009 by KORD_12.7
*
* This file is provided as is (no warranties)
*/
//--------------------------------------------------------------------------------------------------
#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>
//--------------------------------------------------------------------------------------------------
#define PLUGIN "Satchels Life Time"
#define VERSION "1.1"
#define AUTHOR "KORD_12.7"
//--------------------------------------------------------------------------------------------------
//#define DEBUG
//--------------------------------------------------------------------------------------------------
new g_lifeTimeCvar
//--------------------------------------------------------------------------------------------------
public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	register_cvar("sl_version", VERSION, FCVAR_SERVER)
	
	g_lifeTimeCvar = register_cvar("amx_satchel_lifetime", "60")
	
	register_forward(FM_EmitSound, "satchel_exploded")
	RegisterHam(Ham_Spawn, "monster_satchel", "satchel_dropped", 1)
	RegisterHam(Ham_Killed, "player", "check_sathel_tasks", 1)	
}
//--------------------------------------------------------------------------------------------------
public satchel_dropped(ent)
{	
	static args[1], taskid 
	args[0] = ent
	taskid = ent
	
	if(get_pcvar_float(g_lifeTimeCvar) > 0.0)
	{
		set_task (get_pcvar_float(g_lifeTimeCvar), "remove_satchel", taskid, args, sizeof(args), "a", 1)
#if defined DEBUG	
		log_amx("Satchel (ent #%d) dropped, setting task", ent)
#endif	
	}
}
//--------------------------------------------------------------------------------------------------
public satchel_exploded(ent, channel, sample[]) 
{
	if (!pev_valid(ent))
		return FMRES_IGNORED
		
	static classname[32]
	pev(ent, pev_classname, classname, sizeof classname - 1)
	
	if (!equal(classname, "monster_satchel"))
		return FMRES_IGNORED	
	
	if(!(equal(sample, "weapons/debris1.wav") || equal(sample, "weapons/debris2.wav") || equal(sample, "weapons/debris3.wav")))
		return FMRES_IGNORED
	
	if(task_exists(ent))
	{
		remove_task(ent)
#if defined DEBUG		
		log_amx("Satchel (ent #%d) exploded, task removed", ent)
#endif	
	}
	
	return FMRES_IGNORED
}
//--------------------------------------------------------------------------------------------------
public check_sathel_tasks(victim_id)
{
	static ent, owner
	while((ent = engfunc(EngFunc_FindEntityByString, ent, "classname", "monster_satchel"))) 
	{
		if (!pev_valid(ent))
			return FMRES_IGNORED
		
		owner = pev(ent, pev_owner)	
		if(owner == victim_id)
		{
			if(task_exists(ent))
			{
				remove_task(ent)
#if defined DEBUG				
				log_amx("Satchel (ent #%d) task removed, owner died", ent)
#endif				
			}
		}
	}
	
	return FMRES_IGNORED
}
//--------------------------------------------------------------------------------------------------
public remove_satchel(args[])
{
	static ent
	ent = args[0]
	
	if (!pev_valid(ent))		
		return FMRES_IGNORED
		
	static classname[32]
	pev(ent, pev_classname, classname, sizeof classname - 1)
	
	if (!equal(classname, "monster_satchel"))		
		return FMRES_IGNORED
		
	engfunc(EngFunc_RemoveEntity, ent)
#if defined DEBUG	
	log_amx("Satchel (ent #%d) entity removed, task complete", ent)
#endif		
	return FMRES_IGNORED
}
//--------------------------------------------------------------------------------------------------
public client_disconnect(id)
{
	static ent, owner
	
	while((ent = engfunc(EngFunc_FindEntityByString, ent, "classname", "monster_satchel"))) 
	{
		if (!pev_valid(ent))
			return FMRES_IGNORED
		
		owner = pev(ent, pev_owner)	
		if(owner == id)
		{
			if(task_exists(ent))
			{
				remove_task(ent)
				engfunc(EngFunc_RemoveEntity, ent)
#if defined DEBUG				
				log_amx("Satchel (ent #%d) entity and task removed, owner dropped from server", ent)
#endif				
			}
		}
	}
	
	return FMRES_IGNORED
}
